<?php
/*
Plugin Name: Dakwak Widget
Plugin URI: http://dakwak.com
Description: Translate your website with crowdsourcing.
Version: 0.01
Author: Dakwak
Author URI: http://dakwak.com
License: GPLv2
*/

class wp_dakwak extends WP_Widget {

    var $domain = 'http://widget.dakwak.com/api/';


    function wp_dakwak() {
        parent::WP_Widget(false, $name = __('Dakwak Languages', 'wp_dakwak') );
    }

    // widget form creation
    function form($instance) {

    // Check values

        if( $instance) {
            $website_apikey = ($instance['website_apikey']);

        } else {
            $website_apikey = '';
        }

        ?>

        <label for="<?php echo $this->get_field_id('website_apikey'); ?>"><?php _e('Dakwak account API key:', 'wp_dakwak'); ?></label>
        <textarea rows="2" class="widefat" id="<?php echo $this->get_field_id('website_apikey'); ?>" name="<?php echo $this->get_field_name('website_apikey'); ?>"><?php echo $website_apikey; ?></textarea>

        <p>If you don't have one, <a href="http://dakwak.com">sign up at Dakwak</a></p>

    <?php
    }

    // widget update
    function update($new_instance, $old_instance) {
       $instance = $new_instance;
       return $instance;
    }

    // widget display
    function widget($args, $instance) {
        extract( $args );

        $url = "{$this->domain}websites/{$instance['website_apikey']}/widget";

        $request = wp_remote_get($url);
        $code = $request['response']['code'];

        echo $before_widget;

        if(!is_wp_error( $request ) && in_array($code, array('200', '304'))) {

            echo $request['body'];

        } else {
            $error_message = $request['response']['message'];
            echo "Something went wrong. {$code}: $error_message";
        }

        echo $after_widget;
    }
}

// register widget
add_action('widgets_init', create_function('', 'return register_widget("wp_dakwak");'));